package client.view;
import javax.swing.*;
import java.awt.event.*;
import java.awt.*;


/**
* This code was edited or generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
* THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
* LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
*/
public class ClientGUI extends JFrame {


	/**
	 * 
	 */
	private static final long serialVersionUID = -199099598475124566L;

	private static final String DEFAULT_REMOTE_HOST = "localhost"; 

	private IModelAdapter model;

	private JPanel controlPnl;
	private JTextArea outputTA;
	private JButton quitBtn;
	private JTextField inputTF;
	private JTextField remoteHostTF; 

	public ClientGUI(IModelAdapter ma) {
		super("Client GUI");
		model = ma;
		initGUI();
	}

	protected void initGUI() {
		//setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
		this.addWindowListener(new WindowAdapter(){
			public void windowClosing(WindowEvent e){
				quit();
			}
		});
		setSize(800,400);
		controlPnl = new JPanel();
		outputTA = new JTextArea();
		JScrollPane scroll = new JScrollPane(outputTA);
		Container contentPane = getContentPane();
		contentPane.add(controlPnl, BorderLayout.NORTH);
		{
			quitBtn = new JButton();
			controlPnl.add(quitBtn);
			quitBtn.setText("Quit");
			quitBtn.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent evt) {
					quit();
				}
			});
		}
		contentPane.add(scroll, BorderLayout.CENTER); 

		JLabel remoteHostLbl = new JLabel("Remote Host:");
		controlPnl.add(remoteHostLbl);
		remoteHostTF = new JTextField(DEFAULT_REMOTE_HOST);
		remoteHostTF.setPreferredSize(new Dimension(100,25));
		controlPnl.add(remoteHostTF);
		remoteHostTF.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				append("Connecting...\n");
				append(model.connectTo(remoteHostTF.getText())+"\n");
			}
		});

		JLabel paramsLbl = new JLabel("Parameters:");
		controlPnl.add(paramsLbl);
		inputTF = new JTextField("5");
		inputTF.setPreferredSize(new Dimension(100,25));
		JButton calcPiBtn = new JButton("Calculate Pi"); 
		controlPnl.add(inputTF);
		controlPnl.add(calcPiBtn);
		calcPiBtn.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				try {
					append("Calculate Pi: ");
					append(model.calcPi(Integer.parseInt(inputTF.getText()))+"\n");
				}
				catch(Exception excpt) {
					append("Calculate Pi exception: "+excpt+"\n");
				}
			}
		});
	}

	public void quit(){
		System.out.println("ClientGUI: client is quitting...");
		model.quit();
	}
	public void setRemoteHost(String host){
		remoteHostTF.setText(host);
	}
	public void append(String s) {
		outputTA.append(s);
		//Force the JScrollPane to go to scroll down to the new text
		outputTA.setCaretPosition(outputTA.getText().length());
	}
}