package client.view;

/**
 * Adapter the view uses to communicate to the model
 */
public interface IModelAdapter {
  /**
   * Requests that model connect to the RMI Registry at the given remote host
   * @param remoteHost The remote host to connect to.
   * @return A status string regarding the connection result
   */
  public String connectTo(String remoteHost);
  
  /**
   * Execute the Pi task on the remote host, calculating Pi to the given number of digits
   * @param numDigits The number of decimal places to calculate Pi to.
   * @result A string representation of the returned value of Pi
   */
  public String calcPi(int numDigits);
  
  /**
   * Quits the application.
   */
  public void quit();
  
}