package compute;

import java.rmi.*;
/**
 * A abstract task to be run on the computer engine
 */
public interface ITask<T>  {
  /**
   * Executes the task and returns a result
   * @param <T> The type of the returned result
   * @return The result of executing the task.
   */
  public T execute() throws RemoteException;
  
  public void setTaskViewAdapter(ITaskViewAdapter viewAdapter);
}
